/*
 * gtkimcontexttim.h - Table-based Input Method for GTK+ 2 header file.
 *
    Copyright (C) 2002-2003  Yao Zhang

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; version 2 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * yaoz@users.sourceforge.net
 */
#ifndef __GTK_IM_CONTEXT_TIM_H__
#define __GTK_IM_CONTEXT_TIM_H__

#include <gtk/gtk.h>

typedef struct GtkIMContextTIMTag {
    /* Super place holder. */
    GtkIMContext super;

    /* GtkIMContextTIM specific fields. */
    int debug;
    guint carryover_state;
    GdkWindow *client_window;
    gboolean ascii_mode;
    GString *converted;
    GString *raw;
    GString *candidates;
    const guchar *which;
    GtkWidget *candidate_window;
    GtkWidget *candidate_label;
    int showing, x, y, xs, ys;      /* in root window coordinate */
    int auto_commit;
    gchar *id;
} GtkIMContextTIM;
typedef struct {
    /* Super class place holder. */
    GtkIMContextClass super_class;

    /* GSubClass specific methods. */
    void (*set)(GtkIMContextTIM *this, const gchar *id);
} GtkIMContextTIMClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

extern GType gtkimcontexttim_get_type(void);
extern void gtkimcontexttim_register_type(GTypeModule *type_module);

#define GTKIMCONTEXTTIM_TYPE                 (gtkimcontexttim_get_type())
#define GTKIMCONTEXTTIM_CLASS(class)         (G_TYPE_CHECK_CLASS_CAST((class), GTKIMCONTEXTTIM_TYPE, GtkIMContextTIMClass))
#define GTKIMCONTEXTTIM(object)              (G_TYPE_CHECK_INSTANCE_CAST((object), GTKIMCONTEXTTIM_TYPE, GtkIMContextTIM))
#define IS_GTKIMCONTEXTTIM_CLASS(class)      (G_TYPE_CHECK_CLASS_TYPE((class), GTKIMCONTEXTTIM_TYPE))
#define IS_GTKIMCONTEXTTIM(object)           (G_TYPE_CHECK_INSTANCE_TYPE((object), GTKIMCONTEXTTIM_TYPE))
#define GTKIMCONTEXTTIM_GET_CLASS(object)    (G_TYPE_INSTANCE_GET_CLASS((object), GTKIMCONTEXTTIM_TYPE, GtkIMContextTIMClass))

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __GTK_IM_CONTEXT_TIM_H__ */
