/*
 * timtable.h - TIMTable class header file.
 *
    Copyright (C) 2002-2003  Yao Zhang

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; version 2 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * yaoz@users.sourceforge.net
 */
#ifndef TIMTABLE_H
#define TIMTABLE_H

/* Super header. */
#include <glib-object.h>

#include <glib.h>

typedef struct TIMTableTag {
    /* Super place holder. */
    GObject super;

    /* TIMTable specific fields. */
    GHashTable *table;
} TIMTable;
typedef struct {
    /* Super class place holder. */
    GObjectClass super_class;

    /* TIMTableClass specific methods. */
    void (*load)(TIMTable *this, gchar *file_name);
    GString *(*lookup)(TIMTable *this, GString *key);
} TIMTableClass;

#ifdef __cplusplus
extern "C" {
#endif

extern GType timtable_get_type(void);
extern void timtable_register_type(GTypeModule *type_module);

extern void get_im_name(const char *dir, const char *entry, GString *name);

#ifdef __cplusplus
}
#endif

#define TIMTABLE_TYPE                  (timtable_get_type())
#define TIMTABLE_CLASS(class)          (G_TYPE_CHECK_CLASS_CAST((class), TIMTABLE_TYPE, TIMTableClass))
#define TIMTABLE(object)               (G_TYPE_CHECK_INSTANCE_CAST((object), TIMTABLE_TYPE, TIMTable))
#define IS_TIMTABLE_CLASS(class)       (G_TYPE_CHECK_CLASS_TYPE((class), TIMTABLE_TYPE))
#define IS_TIMTABLE(object)            (G_TYPE_CHECK_INSTANCE_TYPE((object), TIMTABLE_TYPE))
#define TIMTABLE_GET_CLASS(object)     (G_TYPE_INSTANCE_GET_CLASS((object), TIMTABLE_TYPE, TIMTableClass))

#define RS      '\x1E'
#define US      '\x1F'

#endif
